#ifdef TERMB_EXPORTS
#define TERMB_API //__declspec(dllexport)
#else
#define TERMB_API __declspec(dllimport)
#endif

typedef int (__stdcall *tSDT_OpenPort)(int iPort);
typedef int (__stdcall *tSDT_ClosePort)(int iPort);
typedef int (__stdcall *tSDT_StartFindIDCard)(int iPort, unsigned char *pucManaInfo, int iIfOpen);
typedef int (__stdcall *tSDT_SelectIDCard)(int iPort, unsigned char *pucManaMsg, int iIfOpen);
typedef int (__stdcall *tSDT_ReadBaseMsg)(int iPort, unsigned char *pcCHMsg, unsigned int *puiCHMsgLen, unsigned char *pcPHMsg, unsigned int *puiPHMsgLen, int iIfOpen);
typedef int (__stdcall *tSDT_ReadBaseMsgToFile)(int iPort, char *pcCHMsgFileName, unsigned int *puiCHMsgFileLen, char *pcPHMsgFileName, unsigned int *puiPHMsgFileLen, int iIfOpen);
typedef int (__stdcall *tSDT_ReadBaseFPMsg)(int iPort, unsigned char *pcCHMsg, unsigned int *puiCHMsgLen, unsigned char *pcPHMsg, unsigned int *puiPHMsgLen, unsigned char *pcFPMsg, unsigned int *puiFPMsgLen, int iIfOpen);
typedef int (__stdcall *tSDT_ReadBaseFPMsgToFile)(int iPort, char *pcCHMsgFileName, unsigned int *puiCHMsgFileLen, char *pcPHMsgFileName, unsigned int *puiPHMsgFileLen, char *pcFPMsgFileName, unsigned int *puiFPMsgFileLen, int iIfOpen);
typedef int (__stdcall *tSDT_ReadNewAppMsg)(int iPort, unsigned char *pucAppMsg, unsigned int *puiAppMsgLen, int iIfOpen);
typedef int (__stdcall *tSDT_GetSAMID)(int iPortID, unsigned char *pucSAMID, int iIfOpen);
typedef int (__stdcall *tSDT_GetSAMIDToStr)(int iPortID, char *pcSAMID, int iIfOpen);
typedef int (__stdcall *tSDT_ResetSAM)(int iPort, int iIfOpen);

#ifdef __cplusplus
extern "C"
{
#endif

TERMB_API int __stdcall InitComm(int Port);
TERMB_API int __stdcall InitCommExt();
TERMB_API int __stdcall CloseComm();
TERMB_API int __stdcall Authenticate();
TERMB_API int __stdcall Read_Content(int Active);

TERMB_API int __stdcall GetSAMID(char *SAMID);

TERMB_API int __stdcall GetBmpPhoto(const char* pszPath);

TERMB_API int __stdcall Reset_SAM();


#ifdef __cplusplus
}
#endif