// IDFPDemoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "IDFPDemo.h"
#include "IDFPDemoDlg.h"
#include "futil.h"
#include "ID_FprCap.h"
#include "ID_Fpr.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#define QUALITYTHRESHOLD 55
#define VERIFYTHRESHOLD 0.97

HMODULE ID_FprCapLib = NULL;
HMODULE ID_FprLib = NULL;
HANDLE hID_FprCap = NULL;
HANDLE hID_Fpr = NULL;
HANDLE thread = NULL;
CString str;
int gStopCapture = false;
int gType = 0; // 0: ʾͼ 1: Ǽ 2: ȶ
int gEnrollIndex = 0;
CRect rect;
CDC	*cdc;
HDC hdc, hdcs;
char pszDesc[1024] = {0};
char pszErrorInfo[256] = {0};
unsigned char pFeatureData[512] = {0};
unsigned char pFeatureDatas[3][512] = {0};
unsigned char nScores[3] = {0};
// CIDFPDemoDlg dialog


int Load_ID_FprCap()
{
	if(ID_FprCapLib)
	{
		return 1;
	}
	ID_FprCapLib = LoadLibrary("ID_FprCap.dll");

	if(NULL == ID_FprCapLib)
	{
		return 0;
	}

	LIVESCAN_Init = (t_LIVESCAN_Init)GetProcAddress(ID_FprCapLib, "LIVESCAN_Init");
	LIVESCAN_Close = (t_LIVESCAN_Close)GetProcAddress(ID_FprCapLib, "LIVESCAN_Close");
	LIVESCAN_GetChannelCount = (t_LIVESCAN_GetChannelCount)GetProcAddress(ID_FprCapLib, "LIVESCAN_GetChannelCount");
	LIVESCAN_GetFPBmpData = (t_LIVESCAN_GetFPBmpData)GetProcAddress(ID_FprCapLib, "LIVESCAN_GetFPBmpData");
	LIVESCAN_GetFPRawData = (t_LIVESCAN_GetFPRawData)GetProcAddress(ID_FprCapLib, "LIVESCAN_GetFPRawData");
	LIVESCAN_GetDesc = (t_LIVESCAN_GetDesc)GetProcAddress(ID_FprCapLib, "LIVESCAN_GetDesc");
	LIVESCAN_GetErrorInfo = (t_LIVESCAN_GetErrorInfo)GetProcAddress(ID_FprCapLib, "LIVESCAN_GetErrorInfo");
	LIVESCAN_SetBright = (t_LIVESCAN_SetBright)GetProcAddress(ID_FprCapLib, "LIVESCAN_SetBright");
	LIVESCAN_SetContrast = (t_LIVESCAN_SetContrast)GetProcAddress(ID_FprCapLib, "LIVESCAN_SetContrast");
	LIVESCAN_GetBright = (t_LIVESCAN_GetBright)GetProcAddress(ID_FprCapLib, "LIVESCAN_GetBright");
	LIVESCAN_GetContrast = (t_LIVESCAN_GetContrast)GetProcAddress(ID_FprCapLib, "LIVESCAN_GetContrast");
	LIVESCAN_GetMaxImageSize = (t_LIVESCAN_GetMaxImageSize)GetProcAddress(ID_FprCapLib, "LIVESCAN_GetMaxImageSize");
	LIVESCAN_GetCaptWindow = (t_LIVESCAN_GetCaptWindow)GetProcAddress(ID_FprCapLib, "LIVESCAN_GetCaptWindow");
	LIVESCAN_SetCaptWindow = (t_LIVESCAN_SetCaptWindow)GetProcAddress(ID_FprCapLib, "LIVESCAN_SetCaptWindow");
	LIVESCAN_Setup = (t_LIVESCAN_Setup)GetProcAddress(ID_FprCapLib, "LIVESCAN_Setup");	
	LIVESCAN_BeginCapture = (t_LIVESCAN_BeginCapture)GetProcAddress(ID_FprCapLib, "LIVESCAN_BeginCapture");
	LIVESCAN_EndCapture = (t_LIVESCAN_EndCapture)GetProcAddress(ID_FprCapLib, "LIVESCAN_EndCapture");	
	LIVESCAN_IsSupportSetup = (t_LIVESCAN_IsSupportSetup)GetProcAddress(ID_FprCapLib, "LIVESCAN_IsSupportSetup");
	LIVESCAN_GetVersion = (t_LIVESCAN_GetVersion)GetProcAddress(ID_FprCapLib, "LIVESCAN_GetVersion");
	LIVESCAN_SetBufferEmpty = (t_LIVESCAN_SetBufferEmpty)GetProcAddress(ID_FprCapLib, "LIVESCAN_SetBufferEmpty");

	if(NULL == LIVESCAN_Init)
	{
		FreeLibrary(ID_FprCapLib);
		return 0;
	}
	return 1;
}

void UnLoad_ID_FprCap()
{
	if(ID_FprCapLib)
	{
		FreeLibrary(ID_FprCapLib);
		ID_FprCapLib = NULL;
	}
}

int Load_ID_Fpr()
{
	if(ID_FprLib)
	{
		return 1;
	}
	ID_FprLib = LoadLibrary("ID_Fpr.dll");

	if(NULL == ID_FprLib)
	{
		return 0;
	}

	FP_GetVersion = (t_FP_GetVersion)GetProcAddress(ID_FprLib, "FP_GetVersion");
	FP_Begin = (t_FP_Begin)GetProcAddress(ID_FprLib, "FP_Begin");
	FP_FeatureExtract = (t_FP_FeatureExtract)GetProcAddress(ID_FprLib, "FP_FeatureExtract");
	FP_FeatureMatch = (t_FP_FeatureMatch)GetProcAddress(ID_FprLib, "FP_FeatureMatch");
	FP_ImageMatch = (t_FP_ImageMatch)GetProcAddress(ID_FprLib, "FP_ImageMatch");
	FP_Compress = (t_FP_Compress)GetProcAddress(ID_FprLib, "FP_Compress");
	FP_Decompress = (t_FP_Decompress)GetProcAddress(ID_FprLib, "FP_Decompress");
	FP_GetQualityScore = (t_FP_GetQualityScore)GetProcAddress(ID_FprLib, "FP_GetQualityScore");
	FP_GenFeatureFromEmpty1 = (t_FP_GenFeatureFromEmpty1)GetProcAddress(ID_FprLib, "FP_GenFeatureFromEmpty1");
	FP_GenFeatureFromEmpty2 = (t_FP_GenFeatureFromEmpty2)GetProcAddress(ID_FprLib, "FP_GenFeatureFromEmpty2");
	FP_End = (t_FP_End)GetProcAddress(ID_FprLib, "FP_End");

	if(NULL == FP_Begin)
	{
		FreeLibrary(ID_FprLib);
		ID_FprLib = NULL;
		return 0;
	}
	return 1;
}

void UnLoad_ID_Fpr()
{
	if(ID_FprLib)
	{
		FreeLibrary(ID_FprLib);
		ID_FprLib = NULL;
	}
}

void UnicodeToMultiByte(char *src, char *dst)
{
	wchar_t wchar[1024] = {0};
	memcpy(wchar, src, 1023);
	int len = wcslen(wchar) + 1;
	WideCharToMultiByte(CP_ACP, 0, wchar, len, dst, len*sizeof(wchar_t), 0, 0);
}

void GetErrorInfo(int ret, char *pszErrorInfo)
{
	char src[256] = {0};
	wchar_t wchar[1024] = {0};
	LIVESCAN_GetErrorInfo(ret, src);
	memcpy(wchar, src, 256);
	int len = wcslen(wchar) + 1;
	WideCharToMultiByte(CP_ACP, 0, wchar, len, pszErrorInfo, len*sizeof(wchar_t), 0, 0);
}

DWORD WINAPI GetImage(LPVOID lParam)
{
	int ret = 0, nWidth = 0, nHeight = 0, ret1 = 0, ret2 = 0, ret3 = 0, maxIndex = 0;
	unsigned char pRawData[256 * 360] = {0}, pFeature = {0}, nScore = 0;
	float pfSimilarity1 = 0.0, pfSimilarity2 = 0.0, pfSimilarity3 = 0.0, aveSimilarity = 0.0;
	BOOL b;
	HWND hwnd = (HWND)lParam;

	while(1)
	{		
		if(gStopCapture)
		{
			break;
		}
		LIVESCAN_BeginCapture(0);
		if((ret = LIVESCAN_GetFPRawData(0, pRawData)) > 0)
		{
			HBITMAP hb = BuildImage(pRawData, 256, 360, true);			
			SelectObject(hdc, hb);
			SetStretchBltMode(hdcs, HALFTONE);
			StretchBlt(hdcs, 0, 0, rect.Width(), rect.Height(), hdc, 0, 0, 256, 360, SRCCOPY);
			DeleteObject(hb);
			hb = NULL;

			ret = FP_GetQualityScore(pRawData, &nScore);
			SetDlgItemInt(hwnd, IDC_STATIC_QUALITY, nScore, false);

			if(1 == gType)
			{
				if(nScore < QUALITYTHRESHOLD)
				{
					str.Format("Fingerprint image quality is poor");
					SetDlgItemText(hwnd, IDC_STATIC_HINT, str);
					gType = 0;
					continue;
				}
				ret = FP_FeatureExtract(255, 11, pRawData, pFeatureDatas[gEnrollIndex]);
				if(1 == ret)
				{
					nScores[gEnrollIndex] = nScore;
					gEnrollIndex++;
					if(3 == gEnrollIndex)
					{
						ret1 = FP_FeatureMatch(pFeatureDatas[0], pFeatureDatas[1], &pfSimilarity1);
						ret2 = FP_FeatureMatch(pFeatureDatas[0], pFeatureDatas[2], &pfSimilarity2);
						ret3 = FP_FeatureMatch(pFeatureDatas[1], pFeatureDatas[2], &pfSimilarity3);

						if((1 != ret1) || (1 != ret2) || (1 != ret3))
						{
							str.Format("FP_FeatureMatch failed, ret1=%d,ret2=%d,ret3=%d", ret1, ret2, ret3);
							SetDlgItemText(hwnd, IDC_STATIC_HINT, str);
						}
						else
						{
							maxIndex = 0;
							if(nScores[1] > nScores[0])
							{
								maxIndex = 1;
							}
							if(nScores[2] > nScores[maxIndex])
							{
								maxIndex = 2;
							}

							aveSimilarity = (pfSimilarity1+pfSimilarity2+pfSimilarity3) / 3.0;
							if(aveSimilarity < VERIFYTHRESHOLD)
							{
								str.Format("Enroll failed, aveSimilarity=%0.2f", aveSimilarity);
								SetDlgItemText(hwnd, IDC_STATIC_HINT, str);
							}
							else
							{
								// Copy max quality image
								memcpy(pFeatureData, pFeatureDatas[maxIndex], 512);
								str.Format("Enroll succeed");
								SetDlgItemText(hwnd, IDC_STATIC_HINT, str);
							}
						}

						gEnrollIndex = 0;
					} //if(3 == gEnrollIndex)
					else if(gEnrollIndex < 3)
					{
						str.Format("Still press %d times fingerprint", 3-gEnrollIndex);
						SetDlgItemText(hwnd, IDC_STATIC_HINT, str);						
					}

					gType = 0;
				}
				else
				{
					str.Format("FP_FeatureExtract failed, ret=%d", ret);
					SetDlgItemText(hwnd, IDC_STATIC_HINT, str);
				}
			}
			else if(2 == gType)
			{
				if(nScore < QUALITYTHRESHOLD)
				{
					str.Format("Fingerprint image quality is poor");
					SetDlgItemText(hwnd, IDC_STATIC_HINT, str);
					continue;
				}
				ret = FP_ImageMatch(pRawData, pFeatureData, &pfSimilarity1);
				if(1 == ret)
				{
					if(pfSimilarity1 > 0.35)
					{
						str.Format("Verify succeed, score=%0.2f", pfSimilarity1);
						SetDlgItemText(hwnd, IDC_STATIC_HINT, str);
					}
					else
					{
						str.Format("Verify failed, score=%0.2f", pfSimilarity1);
						SetDlgItemText(hwnd, IDC_STATIC_HINT, str);
					}
				}
				else
				{
					str.Format("FP_ImageMatch failed, ret=%d", ret);
					SetDlgItemText(hwnd, IDC_STATIC_HINT, str);
				}

				gType = 0;
			}
		}
		else
		{
			SetDlgItemText(hwnd, IDC_STATIC_HINT, _T("ȡʧ"));
		}
		
		LIVESCAN_EndCapture(gStopCapture);
	}

	return 0;
}

CIDFPDemoDlg::CIDFPDemoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CIDFPDemoDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CIDFPDemoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CIDFPDemoDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDOK, &CIDFPDemoDlg::OnBnClickedOk)
	ON_BN_CLICKED(IDC_BTN_INIT, &CIDFPDemoDlg::OnBnClickedBtnInit)
	ON_BN_CLICKED(IDC_BTN_CLOSE, &CIDFPDemoDlg::OnBnClickedBtnClose)
	ON_BN_CLICKED(IDC_BTN_ENROLL, &CIDFPDemoDlg::OnBnClickedBtnEnroll)
	ON_BN_CLICKED(IDC_BTN_VERIFY, &CIDFPDemoDlg::OnBnClickedBtnVerify)
	ON_WM_CLOSE()
END_MESSAGE_MAP()


// CIDFPDemoDlg message handlers

BOOL CIDFPDemoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	cdc = ((CStatic*)GetDlgItem(IDC_STATIC_FP))->GetDC();
	hdcs = cdc->m_hDC;
	hdc  = CreateCompatibleDC(hdcs);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CIDFPDemoDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CIDFPDemoDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CIDFPDemoDlg::OnBnClickedOk()
{
	// TODO: Add your control notification handler code here
	//OnOK();
}

void CIDFPDemoDlg::OnBnClickedBtnInit()
{
	int ret = 0;
	char desc[1024] = {0};

	if(!Load_ID_FprCap())
	{
		MessageBox(_T("Load ID_FprCap.dll failed"));
		return;
	}

	if(!Load_ID_Fpr())
	{
		MessageBox(_T("Load ID_Fpr.dll failed"));
		return;
	}	

	ret = LIVESCAN_Init();
	if(1 != ret)
	{		
		GetDlgItem(IDC_BTN_INIT)->EnableWindow();
		GetDlgItem(IDC_BTN_CLOSE)->EnableWindow(false);
		GetDlgItem(IDC_BTN_ENROLL)->EnableWindow(false);
		GetDlgItem(IDC_BTN_VERIFY)->EnableWindow(false);

		GetErrorInfo(ret, pszErrorInfo);
		str.Format("Init failed, ErrorInfo=%s", pszErrorInfo);
		GetDlgItem(IDC_STATIC_HINT)->SetWindowText(str);
		return;
	}

	ret = LIVESCAN_GetDesc(pszDesc);
	UnicodeToMultiByte(pszDesc+1, desc);

	ret = FP_Begin();
	if(1 == ret)
	{
		str.Format("Init succeed, desc=%s", desc);
		GetDlgItem(IDC_STATIC_HINT)->SetWindowText(str);

		GetDlgItem(IDC_BTN_INIT)->EnableWindow(false);
		GetDlgItem(IDC_BTN_CLOSE)->EnableWindow();
		GetDlgItem(IDC_BTN_ENROLL)->EnableWindow();
		GetDlgItem(IDC_BTN_VERIFY)->EnableWindow();

		((CStatic *)GetDlgItem(IDC_STATIC_FP))->GetClientRect(&rect);

		if(thread)
		{
			return;
		}
		gStopCapture = false;
		thread = CreateThread(NULL, 0, GetImage, this->m_hWnd, 0, NULL);
	}
	else
	{
		GetDlgItem(IDC_STATIC_HINT)->SetWindowText("FP_Begin failed");
		LIVESCAN_Close();
		GetDlgItem(IDC_BTN_INIT)->EnableWindow();
		GetDlgItem(IDC_BTN_CLOSE)->EnableWindow(false);
		GetDlgItem(IDC_BTN_ENROLL)->EnableWindow(false);
		GetDlgItem(IDC_BTN_VERIFY)->EnableWindow(false);
	}
}

void CIDFPDemoDlg::OnBnClickedBtnClose()
{
	if(thread)
	{
		int flag = 0;
		gStopCapture = true;
		DWORD dwRet = 0;
		MSG msg;
		while(TRUE)
		{
			dwRet = WaitForSingleObject(thread, 500);
			switch(dwRet)
			{
			case WAIT_OBJECT_0:
			case WAIT_FAILED:
				flag = 1;
				break;
			case WAIT_TIMEOUT:
				PeekMessage(&msg, NULL, 0, 0, PM_NOREMOVE);
				continue;
			default:
				break; // unexpected failure
			}
			if(1 == flag)
			{
				break;
			}
		}
		CloseHandle(thread);
		thread = NULL;
	}

	LIVESCAN_Close();
	FP_End();

	GetDlgItem(IDC_BTN_INIT)->EnableWindow();
	GetDlgItem(IDC_BTN_CLOSE)->EnableWindow(false);
	GetDlgItem(IDC_BTN_ENROLL)->EnableWindow(false);
	GetDlgItem(IDC_BTN_VERIFY)->EnableWindow(false);
	GetDlgItem(IDC_STATIC_HINT)->SetWindowText("Closed");
}

void CIDFPDemoDlg::OnBnClickedBtnEnroll()
{
	gType = 1;
}

void CIDFPDemoDlg::OnBnClickedBtnVerify()
{
	gType = 2;
}

void CIDFPDemoDlg::OnClose()
{
	if(thread)
	{
		OnBnClickedBtnClose();
	}

	CDialog::OnClose();
}
